﻿#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <Windows.h>
#include <math.h>
#include <stdbool.h>
#include <wchar.h>

void show_sort_menu();
int* set_arr(int N);

void bubble_sort(int arr[], int N);
void selection_sort(int arr[], int N);
void insertion_sort(int arr[], int N);

void swap(int* a, int* b);

void textcolor(int colorNum);
void print_arr(int arr[], int N, int n1, int n2);
void print_bars(int arr[], int size, int highlight1, int highlight2, int color1, int color2);

int main() {      
	int* arr = 0;
	int menu_choice, N = -1;
	void(*sort_func)(int*, int) = 0;

	system("cls");
	while (1) {

		while (1) {
			sort_func = 0;

			show_sort_menu();
			printf("                 선택: ");
			scanf("%d", &menu_choice);

			switch (menu_choice) {
			case 0:
				printf("                 배열의 원소 개수 : ");
				scanf("%d", &N);

				arr = set_arr(N);
				system("cls");
				continue;

			case 1:
				sort_func = bubble_sort;
				break;
			case 2:
				sort_func = selection_sort;
				break;
			case 3:
				sort_func = insertion_sort;
				break;
			default:
				puts("                 잘못된 입력입니다.");
				break;
			}

			system("cls");
			if (N == -1) {
				printf("                 배열의 초기화가 되어있지 않습니다!\n");
				continue;
			}
			if (sort_func) {
				printf("\n");
				sort_func(arr, N);
				printf("\n");
			}
		}
	}
	free(arr);

}

void show_sort_menu() {
	puts("\n-----------------[정렬 알고리즘]-----------------\n");
	puts("                 0. 배열 초기화\n");

	puts("                 1. 버블 정렬");
	puts("                 2. 선택 정렬");
	puts("                 3. 삽입 정렬");
}

int* set_arr(int N) {
	int* arr = (int*)malloc(sizeof(int) * N);
	int random;

	bool* used = (bool*)malloc(sizeof(bool) * N);
	for (int i = 0; i < N; i++) {
		used[i] = false;
	}
	srand((unsigned)time(NULL));

	for (int i = 0; i < N; i++) {
		do {
			random = rand();
			random = (random * (RAND_MAX + 1LL) + rand()) % N + 1;
		} while (used[random - 1]);
		arr[i] = random;
		used[random - 1] = true;
	}
	free(used);
	return arr;
}

void bubble_sort(int arr[], int N) {
	int tmp;

	print_bars(arr, N, -1, -1, 7, 7);

	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N - i - 1; j++) {
			if (arr[j] > arr[j + 1]) {
				tmp = arr[j];
				arr[j] = arr[j + 1];
				arr[j + 1] = tmp;

				print_bars(arr, N, j, j + 1, 12, 12);
			}
		}
	}
}


void selection_sort(int arr[], int N) {
	int min_idx, tmp;

	print_bars(arr, N, -1, -1, 7, 7);

	for (int i = 0; i < N; i++) {
		min_idx = i;
		for (int j = i + 1; j < N; j++) {
			print_bars(arr, N, i, j, 9, 9);
			if (arr[min_idx] > arr[j]) {
				min_idx = j;
			}
		}

		tmp = arr[i];
		arr[i] = arr[min_idx];
		arr[min_idx] = tmp;
		print_bars(arr, N, i, min_idx, 12, 12);
	}
}

void insertion_sort(int arr[], int N) {
	int key, j;

	print_bars(arr, N, -1, -1, 7, 7);

	for (int i = 1; i < N; i++) {
		key = arr[i];
		j = i - 1;

		while (j >= 0 && arr[j] > key) {
			arr[j + 1] = arr[j];

			print_bars(arr, N, j, j + 1, 9, 9);

			j--;
		}
		arr[j + 1] = key;

		print_bars(arr, N, j + 1, i, 12, 12);
	}
}


void textcolor(int colorNum) {
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), colorNum);
}

void print_bars(int arr[], int size, int highlight1, int highlight2, int color1, int color2) {
	HANDLE hConsole = GetStdHandle(STD_OUTPUT_HANDLE);

	COORD cursorPos;
	for (int i = 0; i < size; i++) {
		if (i == highlight1 || i == highlight2) {
			cursorPos.X = 0;
			cursorPos.Y = i;
			SetConsoleCursorPosition(hConsole, cursorPos);
			printf("                                                            ");
		}
	}

	for (int i = 0; i < size; i++) {
		cursorPos.X = 0;
		cursorPos.Y = i;
		SetConsoleCursorPosition(hConsole, cursorPos);

		if (i == highlight1) textcolor(color1);
		else if (i == highlight2) textcolor(color2);
		else textcolor(7);

		printf("%2d | ", arr[i]);
		for (int j = 0; j < arr[i]; j++) {
			printf("■");
		}
		printf("\n");
	}

	textcolor(7);
	Sleep(20);
}
